
#include <stdio.h>
#include <stdint.h>

/* Get our constants and types */
#include "comparison.h"

#include <math.h>

/* Get the helper functions */
#include "comparison-helper.h"


int main(int argc, char **argv) {
  _binary64 x;
  _Decimal64 y;
  int E, F, neg2, neg10;
  uint64_t m, n;
  int res;
  
  if (argc < 6) return -1;

  neg2 = (argv[1][0] == '-');
  E = strtol(argv[2], NULL, 10);
  m = myatoull(argv[3]);
  neg10 = (argv[4][0] == '-');
  F = strtol(argv[5], NULL, 10);
  n = myatoull(argv[6]);

  x = composeBinary(neg2, E, m);
  y = composeDecimal(neg10, F, n);

  printf("Compare x = 0x%016llx ~ %1.50e with y = 0x%016llxz ~ %1.50e\n",*((unsigned long long int *) &x),x,*((unsigned long long int *) &y),(double)y);

  res = compareSignalingLessEqualBinary64Decimal64(x, y);

  printf("Comparison result: x <= y == %s\n", (res ? "true" : "false"));
  
  return 0;
}


