dieonerrormode = on!;
showmessagenumbers = on!;
suppressmessage(162);
suppressmessage(449);
rationalmode = on!;

execute("glue.sol");
externalproc(random, "./externalrandom.so", void -> constant);


/* a <= r < b */
procedure randomInt(a, b) {
          return floor(a + (b - a) * random());
};

binaryFormats = [| { .Emin = -126,
                     .Emax = 127,
                     .p = 24,
                     .printer = string_binary_32,
                     .size = 32,
                     .rounder = SG
                   },
                   { .Emin = -1022,
                     .Emax = 1023,
                     .p = 53,
                     .printer = string_binary_64,
                     .size = 64,
                     .rounder = D
                   },
                   { .Emin = -16382,
                     .Emax = 16383,
                     .p = 113,
                     .printer = string_binary_128,
                     .size = 128,
                     .rounder = QD
                   } 
|];

decimalFormats = [| { .Emin = -383,
                      .Emax = 384,
                      .p = 16,
                      .printer = string_decimal_64,
                      .size = 64
                    },
                    { .Emin = -6143,
                      .Emax = 6144,
                      .p = 34,
                      .printer = string_decimal_128,
                      .size = 128
                    }
|];

numberTestsMantissaPerQuantum = 3;

for binFormat in binaryFormats do {
    for decFormat in decimalFormats do {
        Emin = max(decFormat.Emin, floor(log10(2^(binFormat.Emin - binFormat.p + 1)) + decFormat.p - 1) - 3);
        Emax = min(decFormat.Emax, ceil(log10(2^(binFormat.Emax + 1)) - 1) + 3);
        for E from Emin to Emax by ceil((Emax - Emin)/5000) do {
	    Eprime = E - decFormat.p + 1;
            for q from 1 to decFormat.p do {
                for i from 0 to numberTestsMantissaPerQuantum - 1 do {
                    m = randomInt(0,10^q);
                    for s in [| 0, 1 |] do {
                        decVal = decFormat.printer(s, Eprime, m);
                        if (decVal.class == 0) then {                   
                           t = (-1)^(decVal.s) * 10^(decVal.E) * (decVal.m);
                           bd = round(t,binFormat.rounder,RD);
                           bu = round(t,binFormat.rounder,RU);
                           for bVal in [| bd, bu |] do {
                               if ((bVal == bVal) && (abs(bVal) != infty)) then {
                                  if (bVal < 0) then sb = 1 else sb = 0;
                                  Eb = exponent(abs(bVal));
                                  mb = mantissa(abs(bVal));
                                  binVal = binFormat.printer(sb, Eb, mb);
                                  if (binVal.class == 0) then {
				     u = (-1)^(binVal.s) * 2^(binVal.E) * (binVal.m);
				     res = (u <= t);
                                     write("b", binFormat.size, " d", decFormat.size, " ", binVal.str, " ", decVal.str, " ", res, "\n");
                                  };
                               };
                           };
                        };
                    };
                };
            };
        };
    };
};
