externalproc(string_binary_32_glue, "./glue.so", (integer, integer, integer, integer) -> list of object);
externalproc(string_binary_64_glue, "./glue.so", (integer, integer, integer, integer, integer, integer) -> list of object);
externalproc(string_binary_128_glue, "./glue.so", (integer, integer, integer, integer, integer, integer, integer, integer, integer, integer) -> list of object);

externalproc(string_decimal_64_glue, "./glue.so", (integer, integer, integer, integer, integer, integer) -> list of object);
externalproc(string_decimal_128_glue, "./glue.so", (integer, integer, integer, integer, integer, integer, integer, integer, integer, integer) -> list of object);

procedure string_binary_32(s, E, m) {
	  var M;
	  var M1, M2;
	  var res;

	  M = m - 2^32 * floor(m / 2^32);

	  M1 = floor(M / 2^16); M = M - M1 * 2^16;
	  M2 = M;

	  res = string_binary_32_glue(s, E, M1, M2);

	  return { .str = res[0], .class = res[1], .s = res[2], .E = res[3], .m = res[4] };
};

procedure string_binary_64(s, E, m) {
	  var M;
	  var M1, M2, M3, M4;
	  var res;

	  M = m - 2^64 * floor(m / 2^64);

	  M1 = floor(M / 2^48); M = M - M1 * 2^48;
	  M2 = floor(M / 2^32); M = M - M2 * 2^32;
	  M3 = floor(M / 2^16); M = M - M3 * 2^16;
	  M4 = M;

	  res = string_binary_64_glue(s, E, M1, M2, M3, M4);

	  return { .str = res[0], .class = res[1], .s = res[2], .E = res[3], .m = res[4] };
};

procedure string_binary_128(s, E, m) {
	  var M;
	  var M1, M2, M3, M4, M5, M6, M7, M8;
	  var res;

	  M = m - 2^128 * floor(m / 2^128);

	  M1 = floor(M / 2^112); M = M - M1 * 2^112;
	  M2 = floor(M / 2^96); M = M - M2 * 2^96;
	  M3 = floor(M / 2^80); M = M - M3 * 2^80;
	  M4 = floor(M / 2^64); M = M - M4 * 2^64;
	  M5 = floor(M / 2^48); M = M - M5 * 2^48;
	  M6 = floor(M / 2^32); M = M - M6 * 2^32;
	  M7 = floor(M / 2^16); M = M - M7 * 2^16;
	  M8 = M;

	  res = string_binary_128_glue(s, E, M1, M2, M3, M4, M5, M6, M7, M8);

	  return { .str = res[0], .class = res[1], .s = res[2], .E = res[3], .m = ((2^64 * res[4]) + res[5]) };
};



procedure string_decimal_64(s, E, m) {
	  var M;
	  var M1, M2, M3, M4;
	  var res;

	  M = m - 2^64 * floor(m / 2^64);

	  M1 = floor(M / 2^48); M = M - M1 * 2^48;
	  M2 = floor(M / 2^32); M = M - M2 * 2^32;
	  M3 = floor(M / 2^16); M = M - M3 * 2^16;
	  M4 = M;

	  res = string_decimal_64_glue(s, E, M1, M2, M3, M4);

	  return { .str = res[0], .class = res[1], .s = res[2], .E = res[3], .m = res[4] };
};

procedure string_decimal_128(s, E, m) {
	  var M;
	  var M1, M2, M3, M4, M5, M6, M7, M8;
	  var res;

	  M = m - 2^128 * floor(m / 2^128);

	  M1 = floor(M / 2^112); M = M - M1 * 2^112;
	  M2 = floor(M / 2^96); M = M - M2 * 2^96;
	  M3 = floor(M / 2^80); M = M - M3 * 2^80;
	  M4 = floor(M / 2^64); M = M - M4 * 2^64;
	  M5 = floor(M / 2^48); M = M - M5 * 2^48;
	  M6 = floor(M / 2^32); M = M - M6 * 2^32;
	  M7 = floor(M / 2^16); M = M - M7 * 2^16;
	  M8 = M;

	  res = string_decimal_128_glue(s, E, M1, M2, M3, M4, M5, M6, M7, M8);

	  return { .str = res[0], .class = res[1], .s = res[2], .E = res[3], .m = ((2^64 * res[4]) + res[5]) };
};


